<template>
<#if ctrl.render??>
    ${ctrl.render.code}
<#else>
    <div class="app-dr-tab<#if ctrl.getPSSysCss?? && ctrl.getPSSysCss()??><#assign singleCss = ctrl.getPSSysCss()> ${singleCss.getCssName()}</#if>">
        <div v-for="(item, index) in items" :class="{ 'app-dr-tab-item': true, 'dr-tab-item': true, 'is-disabled': item.disabled, 'is-active': selection.id === item.id }">
            <span class="text">{{ item.text }}</span>
        </div>
    </div>   
</#if> 
</template>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/FUNC/MACRO.ftl
</#ibizinclude>

    /**
     * 是否显示插槽
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop({default:true}) public isShowSlot?: boolean;

    /**
     *  应用实体参数名称
     *
     * @type string
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public parentName!: string;

    /**
     * 表单数据
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public formData: any;
    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getDatas(): any[] {
        return this.items;
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getData(): any {
        return this.selection;
    }

    /**
     * 数据选中项
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public selection: any = {};

    /**
     * 父数据
     *
     * @public
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public parentData: any = {};

    /**
     * 关系栏数据项
     *
     * @type {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public items: any[] = [
<#if ctrl.getPSDEDRTabPages?? && ctrl.getPSDEDRTabPages()??>
    <#list ctrl.getPSDEDRTabPages() as item>
        {
            id: '${item.getId()?lower_case}',
            name: '${item.getId()?lower_case}',
            text: '${item.getCaption()}',
            disabled: true,
            navView: '<#if item.getPSAppView?? && item.getPSAppView()??>${srffilepath2(item.getPSAppView().codeName)}</#if>',
        <#if item.getPSSysImage()??>
            iconcls: '${item.getPSSysImage().getCssClass()}',
            icon: '${item.getPSSysImage().getImagePath()}',
        </#if>
            localContext: <#if item.getPSNavigateContexts?? && item.getPSNavigateContexts()??><@getNavigateContext item /><#else>null</#if>,
            localViewParam: <#if item.getPSNavigateParams?? && item.getPSNavigateParams()??><@getNavigateParams item /><#else>null</#if>
        }
    </#list>
</#if>
    ];

    /**
     * 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 仿真选中第一项
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public selectFirst(){
        if (this.items.length > 0){
            this.isShowSlot?this.tabPanelClick(this.items[0].name):this.items.length>1?this.tabPanelClick(this.items[1].name):()=>{};
        }
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('state', action)) {
                    const state = !this.context.${ctrl.getPSAppDataEntity().getCodeName()?lower_case} ? true : false;
                    this.setItemDisabled(state);
                    this.formData = data;
                    this.selectFirst();
                }
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 获取关系项
     *
     * @public
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getDRTabItem(arg: any = {}): any {
        let expmode = arg.nodetype.toUpperCase();
        if (!expmode) {
            expmode = '';
        }
        <#list ctrl.getPSAppViewRefs() as item>
        <#if (item.getName()?index_of("DRITEM:")==0)>
        <#assign refview = item.getRefPSAppView()>
        if (Object.is(expmode, '${item.getName()?substring(7)}')) {
            return {  
                viewname: '${srffilepath2(refview.codeName)}', 
                parentdatajo: <#if item.getParentDataJO()??>${item.getParentDataJO()}<#else>{},</#if>
			};
        }
        </#if>
        </#list>
        return undefined;
    }

    /**
     * 获取数据项
     *
     * @public
     * @param {string} id
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getItem(id: string): any {
        const arr: any[] = this.items.filter((_item: any) => Object.is(_item.id, id));
        if (arr) {
            return arr[0];
        }
        return null;
    }

    public handleFormDataChange(data: any) {
        this.formData = data;
        if (data && Object.is(data.srfuf, '1')) {
            this.items.forEach((item: any) => {
                item.disabled = false;
            })
        } else {
            this.items.forEach((item: any) => {
                item.disabled = true;
            })
        }
    }

    /**
     * 选中节点
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public tabPanelClick($event: any): void {
        //  const item = this.getItem($event);
        //  if (Object.is(item.id, this.selection.id)) {
        //      return;
        //  }
        //  this.$emit('selectionchange', [item]);
        //  let localNavParam:any = this.initNavParam(item);
        //  const refview = this.getDRTabItem({ nodetype: item.id });
        //  this.selection = {};
        //  const _context: any = { ...JSON.parse(JSON.stringify(this.context)) };
        //  if(localNavParam && localNavParam.localContext){
        //      Object.assign(_context,localNavParam.localContext);
        //  }
        //  Object.assign(_context,{srfparentdename:this.parentName,srfparentkey:_context[this.parentName.toLowerCase()]});
        //  const _params: any = {};
        //  if(localNavParam && localNavParam.localViewParam){
        //      Object.assign(_params,localNavParam.localViewParam);
        //  }
        //  if (refview && refview.parentdatajo) {
        //      Object.assign(_context, refview.parentdatajo);
        //     Object.assign(this.selection, { view: { viewname: refview.viewname }, data: _context, param: _params });
        //  }
        //  Object.assign(this.selection, item);
    }

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>